#include "m33.h"

#include <iostream>

V3& M33::operator[](int i) {

  return rows[i];

}

ostream& operator<<(ostream &os, M33 m) {

  os << m[0] << endl;
  os << m[1] << endl;
  os << m[2] << endl;
  return os;
}

V3 M33::operator*(V3 v) {

  V3 ret(rows[0]*v, rows[1]*v, rows[2]*v);
  return ret;

}

M33 M33::operator*(M33 m1) {

  M33 ret;
  M33 &m0 = (*this);
  ret.SetColumn(0, m0*m1.GetColumn(0));
  ret.SetColumn(1, m0*m1.GetColumn(1));
  ret.SetColumn(2, m0*m1.GetColumn(2));
  return ret;

}

void M33::Normalize() {

  V3 vs = rows[0] + rows[1] + rows[2];
  float sum = vs[0] + vs[1] + vs[2];

  rows[0] = rows[0] / sum;
  rows[1] = rows[1] / sum;
  rows[2] = rows[2] / sum;


}

M33 M33::Inverse() {

  M33 ret;
  V3 a = GetColumn(0), b = GetColumn(1), c = GetColumn(2);
  V3 _a = b ^ c; _a = _a / (a * _a);
  V3 _b = c ^ a; _b = _b / (b * _b);
  V3 _c = a ^ b; _c = _c / (c * _c);
  ret[0] = _a;
  ret[1] = _b;
  ret[2] = _c;

  return ret;

}

V3 M33::GetColumn(int i) {

  V3 ret(rows[0][i], rows[1][i], rows[2][i]);
  return ret;

}

void M33::SetColumn(int i, V3 ci) {

  rows[0][i] = ci[0];
  rows[1][i] = ci[1];
  rows[2][i] = ci[2];

}
